package weka.classifiers.TzuCheng.tpst;

import weka.core.matrix.*;
import weka.core.Instance;
import weka.core.Instances;

public class InstancesMatrix {
  /** The stored instances. */
  protected Instances m_data;            
  protected Distribution m_distribution; 
  /**
   * Constructor. 
   */
  public InstancesMatrix (Instances data){
    	setInstances(data);
    	try{
    	  m_distribution= new Distribution(data);
    	  
    	}catch(Exception e){
    	  System.out.println("There is error while computing distribution");
    	}
  }
  
  public void setInstances (Instances data) {
    
	m_data =new Instances(data);
  }
  
  public Instances getInstances ()  {
    
	return m_data;
  }
  
  
  public Matrix getMatrix_onlyData ()  {
    double [][] stored_data;
    stored_data=new double[m_data.numInstances()][];
    for(int i=0;i<m_data.numInstances();i++){
      double [] onerow= new double[m_data.numAttributes()-1];
      onerow=m_data.instance(i).toDoubleArray();
      
      double [] onerow_removeClass= new double[m_data.numAttributes()-1];
      for (int j=0;j<m_data.numAttributes();j++){
	if (j!=m_data.classIndex())
		onerow_removeClass[j]=onerow[j];
      }
      
      stored_data[i]=onerow_removeClass; 
    }
    return new Matrix(stored_data);
  }
  
  /**
   * Get those instances which belong to need_classIndex
   * and convert it to Matrix form 
   * */
  
  public Matrix getMatrix_InClass (int []need_classIndex)  {
    Instances need_Instances= getInstances_InClass (need_classIndex);
    double [][] stored_data;
    stored_data=new double[need_Instances.numInstances()][];
    for(int i=0;i<need_Instances.numInstances();i++){
      double [] onerow= new double[need_Instances.numAttributes()];
      onerow=need_Instances.instance(i).toDoubleArray();
      
      double [] onerow_removeClass= new double[need_Instances.numAttributes()-1];
      for (int j=0;j<need_Instances.numAttributes();j++){
	if (j!=need_Instances.classIndex())
		onerow_removeClass[j]=onerow[j];
      }
      
      stored_data[i]=onerow_removeClass; 
    }
    return new Matrix(stored_data);
  }
  
  /**
   * Get those instances which belong to need_classIndex 
   * */
  protected Instances getInstances_InClass (int []need_classIndex)  {
    Instances source=m_data;
       
    Instances ans=new Instances(source, source.numInstances()) ;
    for(int i=0;i<source.numInstances() ;i++){
      Instance local_instance=new Instance(source.instance(i));
      
      int classID= (int)local_instance.value(source.classIndex());
      
      for (int j=0;j<need_classIndex.length;j++){
	if (classID==need_classIndex[j])
      		ans.add(local_instance);
      }
    }
    
    
    return ans;
	
  }
  
  public double num_InClass (int need_classIndex)  {
    
    return m_distribution.perClass(need_classIndex) ;
  }
  
}
